Overview

DDE Panel displays data from any type of channel. It also acts as a DDE Server.

It can handle any number of channels, in any combination of analogue and digital, input and output. Channels in a full alarm state are shown on a red background; those in a warning alarm state are shown on a blue background.

Although the panel shows data from output channels, but you cannot change these values from here. Use AnalogOut or DigitalOut instead.

DDE Panel reads all connected channels at a specified rate - the refresh rate.

You can resize the DDE Panel window to show only the details currently needed, or minimise it to an icon. If more channels are present than can be displayed, use the scroll bar or Home and End keys to show others.

When you start DDE Panel, the first thing to do is either:

  1. Load a hardware setup file (*.ims) which was previously created using the SetupIML program, or
  2. Restore a complete DDE Panel setup which was saved during a previous session.


Configuring the Hardware

You configure the data acquisition hardware simply by sending it a hardware setup file (which was created with the SetupIML program). Before you can display data you must choose which setup file to use.

  1. Select Load Hardware Setup from the File menu. A dialogue box appears where you can choose to load a setup file from disk or select one that is already in use by another Windmill application. If the applications have channels in common you must specify the same setup file for each.
  2. Select a setup file and it is displayed in the File Name box. Select OK and the file is loaded, the hardware configured and you can now select which channels will be displayed by the panel. (Alternatively double-click on the desired file or type the name into the File Name box then select OK.)

If you prefer you can load the hardware setup file at the same time you load DDE Panel.


Selecting Channels to Display

You must choose which channels you want DDE Panel to display, and connect these channels to the panel. Do this in the Channel Connections box, which appears automatically when you select a hardware setup file or when you select Connections from the menu bar.

Connecting channels

Initially all channels are unconnected and listed in the left hand box. To connect a channel select it and choose the Connect button. It will now be displayed in the right hand Connected Channels list. Alternatively double-click channels to connect them.

Disconnecting channels

To disconnect a channel select it from the right hand box and press the Disconnect button. It will swap back to the Unconnected Channels list. Alternatively double-click channels to disconnect them.

When you've connected channels DDE panel will start to display data, updating the readings at the specified refresh rate.

Note that you can't redefine connections while a DDE conversation is in progress. If a new hardware setup file is loaded then the current connections will be lost.


Stopping the Panel

The only way to stop DDE Panel updating values is to close the program.


Changing the Refresh Rate

The DDE Panel reads all the connected channels every so many seconds. This time is known as the refresh rate.

To change the refresh rate simply erase the current value in the main window, and type a new one. The minimum refresh rate is 0.1 seconds and the maximum 9999 seconds.

If Windows is busy, or the refresh rate is too short to read all the connected channels, it may not be possible to achieve the specified rate. In this case data will be read as fast as possible.


Turning the Units On and Off

Choose Units from the Display menu to turn the units on and off.

Removing the units may allow DDE Panel to display more channels.

The units are specified in SetupIML.


Turning the Status Bar On and Off

Choose Status Bar from the Display menu to turn the status bar on and off.

The status bar shows DDE information. Removing the status bar may allow DDE Panel to display more channels.


Saving DDE Panel's Setup Details

You can save the details you've specified in DDE Panel and restore them in the future.

  1. Select Save Panel Setup from the File menu - a dialogue box appears.
  2. Type a name into the File Name box. There is no need to specify an extension as .wdp will be automatically added.
  3. Choose OK and the details will be stored in this file in the working directory.
  4. To save the file in a different directory either type the drive, directory and file name into the File Name box or use the Drives and Directories list boxes to change directories.

The panel setup file contains the following details:

  • name of hardware setup file to use
  • connected channels
  • whether the status bar is shown or not
  • whether the units are shown or not
  • the refresh rate (interval) in milliseconds
  • the DDE service name
  • the password allowing other users to access data over network DDE
  • size and position of the panel window


Restoring DDE Panel's Setup Details

To restore a previously saved setup

  1. Select Restore Panel Setup from the File menu. A dialogue box appears with a list of all files with a .wdp extension in the current directory.
  2. Select a setup file and on choosing OK all the setup details will be restored.

You can also automatically restore the panel settings when you load DDE Panel, by including the setup file name in the command line.

If the panel is engaged in a DDE conversation when you restore the setup file, the new DDE service name will not be loaded.


Loading the Setup Details Automatically

You can configure DDE Panel to start with either a panel setup file (*.wdp) or a hardware setup file (*.ims) already loaded. So when you load DDE Panel you also configure the hardware, position the window, connect channels, specify the refresh rate, and so on.

  1. On the Windows desktop right-click the DDE Panel icon [image].
  2. Select Properties and choose the Shortcut tab.
  3. Add the setup file name to the Target box.

For a DDE Panel setup file called mysetup.wdp, the target will look like this
"C:\Program Files\Windmill Software\Windmill\Wmdde.exe" Setups\mysetup.wdp
The .wdp file contains a reference to an IMS file so this will be loaded too.

To load just a hardware setup type:
"C:\Program Files\Windmill Software\Windmill\Wmdde.exe" Setups\mysetup.ims
inserting the correct ims file. When you load DDE Panel the hardware will be configured as specified but the DDE Panel settings will be at their default values.


Automatically Starting DDE Panel when you Switch on the Computer

You can fully automate DDE Panel so it starts as soon as you switch on the computer. To do this, having first saved a DDE Panel setup file, proceed as follows.

  1. Add a DDE Panel setup file to DDE Panel's command line argument.

    When loaded DDE Panel will be fully configured.

  2. Copy the DDE Panel icon to the StartUp program group

    In Windows 7

    1. Click the Windows Start button [image] , click All Programs, right-click the Startup folder and select Open.
    2. In Computer [image], open the Windmill Software folder, which by default is in the Program Files (x86) folder.
    3. Right-click DDE Panel. Choose Create Shortcut. This may be placed in the Windows folder or on the desktop.
    4. Drag the shortcut into the Startup folder which is at windows\start menu\programs\startup.

    In Earlier versions of Windmill

    1. Launch Windows Explorer and open the Windmill folder. Copy DDE Panel (right click the panel icon and choose copy).

    2. Open the Windows\Start Menu\Programs\StartUp folder and paste DDE Panel there.

When you next start Windows, DDE Panel will automatically be loaded.


Altering the Hardware Setup File

Alter the hardware setup file (*.ims) with the SetupIML program. You can move to SetupIML and change some of the details in the current setup file without closing DDE Panel (as long as no DDE conversation is in progress and the channels are not in use by another application).

The panel will pause while you edit the setup file. When you close SetupIML the panel restarts and the affected parameters are updated.

If you rename a channel then DDE Panel will disconnect that channel. Reconnect it with the Connections menu.


Closing DDE Panel

Select the File menu and choose the Exit command.


Sharing Information with Other Applications

You can share data and other information with other applications, like Excel. To do this you use dynamic data exchange, or DDE.

The Copy to Clipboard button lets you copy information about your channels to the clipboard. You can then paste the contents of the clipboard into another application supporting DDE. (This only works on a single computer, not across a network.)

You can choose which type of information (the DDE topic) you want to copy, and whether you want to copy details from all channels or just from the selected ones. The Copy All Channels button uses the DDE data item "AllChannels". This reduces DDE traffic since a single request/response is made over DDE which returns the data for all channels.

Paste or Paste Link?

You can paste the channel references into any application that has a Paste or Paste Link facility. Use the Paste menu option to show the data at the time you copied it to the clipboard, and the Paste Link option to acquire new data as it becomes available.

To Summarise

  1. Select channels and press the Copy to Clipboard button.
  2. Choose what you want to copy: channel readings, channel names, channel ranges, channel units, alarm states or error codes.
  3. Select Paste or Paste Link in the other application.


Selecting which Channels are Copied to the Clipboard

You can copy information about all channels connected to the DDE Panel, or about just a few of them. (You don't need to select any channels if you want to copy information about all of them.)

To select a channel just click the mouse pointer over it. To select additional channels hold down the Control key whilst clicking more channels. To select a block of channels hold down the shift key. Alternatively you can select channels using the keyboard. After selecting channels press the Copy to Clipboard button.

Summary of mouse and keyboard selections

Move focus to previous channel | Cursor Up Arrow
Move focus to next channel | Cursor Down Arrow
Move to next column | Cursor Right Arrow
Move to previous column | Cursor Left Arrow
Move to first channel currently displayed | Home
Move to last channel currently displayed | End
Move to very first channel | Ctrl-Home
Move to very last channel | Ctrl-End
Select a channel whilst maintaining previous selections | Ctrl-Mouse click
Deselect a channel | Ctrl-Mouse click or move focus
Select a block of channels | Shift-Mouse click or Shift-Cursor Up/Down/Left/Right Arrow


Types of Information: DDE Topics

Data Topic

The Data topic copies the current readings of the selected channels.

Name Topic

The Name topic copies the names of the selected channels.

Range Topic

The Range topic copies the minimum value each channel can read with its current configuration, and the maximum value. This information can be used for scaling graph axes. (Certain hardware drivers may not supply this information, in which case the standard values of 0 and 100 will be given.)

Units Topic

The Units topic copies the units of the selected channels.

Alarm Topic

The Alarm topic copies the alarm state of the selected channels.

0 - No Alarm

1 - Warning Alarm

2 - Critical Alarm

Error Topic

The Error topic copies the error state of the selected channels. This is the error code from the most recent attempt to read data from the each channel. A code of 0 shows that the channel was read successfully.


Sending Commands to the DDE Panel from Other Applications

You can send commands to the DDE Panel from other applications.

Destroy

Closes the panel

Interval <rate>

Sets the refresh rate in seconds.

Load <full setup path name>

Loads the specified DDE panel setup file. If no file is specified, the panel will prompt you with the standard File Open dialogue box.

Maximize

Maximises the panel to full screen size

Minimize

Iconises the panel

Move <xpos> <ypos> <xsize> <ysize>

Move and resizes the panel. All values are in pixels.

Restore

Restores the panel to the size it was before it was minimised or maximised.

For example, to minimise the panel from Excel, using Excel Visual Basic Macro Language, you would send a DDE Execute command as follows.

Sub Minimise ()

ddechan = DDEInitiate ("Windmill", "Commands")

DDEExecute ddechan, "Minimize"

DDETerminate (ddechan)

End sub


Network DDE

Network DDE means that real-time data from Windmill can be pasted into applications on other computers anywhere on the network. The mechanism for this is provided by a DDE Share. You must create a DDE Share on the computer running DDE Panel - remote computers can then access this share to pass data. The share specifies the DDE Service Name and the topic on which you wish to pass data. It also provides security features. To create the share use the DDEShare utility supplied by Microsoft. The details of this depend on the operating system that you are using. (DDEShare should be on your computer - however, if you are unable to locate this program please contact Windmill Software and we will send you a copy.)

DDE Panel on a Windows 98 System

When you run DDEShare on these systems and ask to create a new share, you are prompted for:

Share NameAny name you choose to create. It should end in a $.

Application NameThis is the service name you entered in DDE Panel.

Topic NameAny of the available topics but normally Data.

Item NameLeave Blank.

Start Application on ConnectLeave UnChecked.

Type of AccessFull.

Full Access PasswordYou can enter a Password here if you desire or leave it blank.

You have now created the DDE Share.

DDE Panel on an NT system

When you run DDEShare on an NT system a whole folder appears. From the Shares menu select DDEShares and choose Add a Share. You are now prompted for:

Share NameAny name you choose to create. It should end in a $.

Application Name / Topic Name

Old Style and New StyleLeave blank.

Application Name StaticThis is the service name which you entered in DDE Panel.

Topic Name StaticAny of the available topics but normally Data.

Allow Start ApplicationLeave Blank.

Is ServiceLeave Blank.

Item SecurityGrant access to all items.

Now select Permissions to bring up an additional dialogue.

Select ADD, choose NETWORK and give it FULL CONTROL. Now press OK.

You have now created the DDE Share. In the NT security system this is the property of the machine. An individual user must 'Trust' the share before access to the DDE source will be allowed. To trust the share, from the Shares menu select DDE Shares. Now select the share, followed by Trust Share, then OK the next dialogue. The DDE share is now trusted when you are the user of the computer. It will not work for other users of the machine unless they also trust it.

You must also ensure that the user of the distant computer that wishes to get data from the DDE Share is an authorised user. This is done by the User Manager utility. You must be logged on as an Administrator to give this authorisation.

Accessing the Data

In local DDE data is accessed by a 3 item address :

Service NameTopic NameItem

egWINDMILLData00000

In the syntax of Excel this would be

='WINDMILL'|'Data'!'00000'

It would access channel 00000 of the Data topic at the WINDMILL service name.

In Network DDE the same structure is used in a slightly different way :

Service NameTopic NameItem

eg\\Production\NDDE$OVEN$00000

In the syntax of Excel this would be

='\\Production\NDDE$'|'OVEN$'!'00000'

It would access channel 00000 of the DDE share OVEN$ located on the computer named Production. The \s and the NDDE$ show that this is a DDE share on a distant computer.

Linking DDE Panel to Excel between Two Non NT Computers

Open DDE Panel on the machine where you have created a share, and start reading data. Open Excel on the distant machine. Type the DDE address as above into the Excel formula window. If you have not specified a password then communication is established when you press return. If you have specified a password then you will be prompted for it.

Linking DDE Panel on a Non NT computer to Excel on an NT computer

As Above

Linking DDE Panel on an NT computer to Excel on a Non NT Computer

As above except that the Non NT computer user must be an authorised user of the NT computer, and the user of the DDE Panel machine must trust the DDE share. You will always be asked for a password: use the one with which you logged onto the non NT computer.

Linking DDE Panel to Excel between Two NT Computers :

Log onto the DDE Panel machine as a trusted user of the DDE share that you have created. Open DDE Panel and start reading data. Log onto the distant computer as a user who is allowed access to the DDE Panel machine. Start Excel and enter a DDE address as above into the formula window. Communication is established when you press return.


Example Excel macro

Example Excel Macro, written in Excel Visual Basic

This macro repeatedly samples data from all channels connected to the DDE Panel. It stores the data in the Excel worksheet. When the macro is run the operator chooses how many times to sample all the channels, and the interval between taking sets of samples. The macro loops until the required amount of samples have been collected. Comments are shown in italic

For more macros, and tips on using Excel for data acquisition, please see the Windmill web site.

Sub Macro1()

'When the number of rows is equal to the number of sets of samples requested, the macro will stop.

NoOfRows = 1

'Ask for no. of sets of samples and sample interval.

NoOfSamples = Val(InputBox("Please enter no of samples to collect", "No of Samples"))

SamplePeriod = InputBox("Please enter sample interval in seconds", "Sample Interval")

'Coverts interval to fraction of 24 hours (Excel expects times in this format).

SamplePeriod = (Val(SamplePeriod)) / 86400

'Initiates conversation with DDE_Panel

ddeChan = DDEInitiate("Windmill", "Data")

'Keeps conversation open until the required number of'samples have been collected.

While NoOfRows < NoOfSamples + 1

'Requests data from all channels and stores it in memory in an array called mydata.

mydata = DDERequest(ddeChan, "AllChannels")

'Selects first sheet in default workbook.

Sheets("Sheet1").Select

'Finds the lower & upper boundaries of array, to determine the number of columns needed to store the data.

Lower = LBound(mydata, 1)

Upper = UBound(mydata, 1)

'Inserts data from the array into a row of cells.

For Column = Lower To Upper

Cells(NoOfRows,Column).Value = mydata(Column)

Next Column

'Waits for the specified sample interval.

Application.Wait (Now + SamplePeriod)

'Increments number of rows, so next set of samples is inserted in the next row down.

NoOfRows = NoOfRows + 1

'Stops loop when required sets of samples collected.

Wend

DDETerminate (ddeChan)

End Sub


Example Excel Macro to Read Data

This example shows an Excel macro, written in the Excel Visual Basic language, which reads data from one channel (Chan_00) connected to the Windmill DDE Panel and places it into a cell (A1) in the spreadsheet. Comments are shown in italic.

For more macros, and tips on using Excel for data acquisition, please see the Windmill web site.

Sub DDEread()

'Opens a DDE conversation with the Windmill DDE 'Panel using the Service Name "Windmill" and the 'Topic Name "Data"

ddeChan = Excel.DDEInitiate("Windmill", "data")

'Requests data from a channel called Chan00.

myData = Excel.DDERequest(ddeChan, "Chan_00")

Sheets("sheet1").Select

Cells(1,1).Value = myData

'Closes the DDE conversation.

Excel.DDETerminate (ddeChan)

End Sub

For more macros, and tips on using Windmill with Excel, see the Windmill web site -

http://www.windmill.co.uk/excel.html


Example Excel Macro to Send Data to an Output Channel

This example shows an Excel macro, written in the Excel Visual Basic language, which sends data to an analogue or digital output channel. Here the data is in Sheet1.Cell.A1 and the output channel is called Blackb_1. Comments are shown in italic.

For more macros, and tips on using Excel for data acquisition, please see the Windmill web site.

Sub DDEpoke()

'Opens a DDE conversation with the Windmill

'DDE Panel using the Service Name "Windmill"

'and the Topic Name "Data"

ddeChan = Excel.DDEInitiate("Windmill", "data")

'Now send the data.

'Note the 3rd parameter MUST be a cell or range of

'cells which contain the data

Excel.DDEpoke ddeChan, "Blackb_1", Range("a1")

'Closes the DDE conversation.

Excel.DDETerminate (ddeChan)

End Sub

For more macros, and tips on using Windmill with Excel, see the Windmill web site -

http://www.windmill.co.uk/excel.html

Related topics:

Example Excel macro to read data

Example Excel macro to repeatedly sample data


Example Excel Macro to Repeatedly Sample Data

This macro repeatedly samples data from all channels connected to the DDE Panel. It stores the data in the Excel worksheet. When the macro is run the operator chooses how many times to sample all the channels, and the interval between taking sets of samples. The macro loops until the required amount of samples have been collected. Comments are shown in italic.

For more macros, and tips on using Excel for data acquisition, please see the Windmill web site.

Sub Macro1()

'When the number of rows is equal to the number of sets of samples

‘requested, the macro will stop.

NoOfRows = 1

'Ask for no. of sets of samples and sample interval.

NoOfSamples = Val(InputBox("Please enter no of samples to collect", "No of Samples"))

SamplePeriod = InputBox("Please enter sample interval in seconds", "Sample Interval")

'Coverts interval to fraction of 24 hours (Excel expects times in this format).

SamplePeriod = (Val(SamplePeriod)) / 86400

'Initiates conversation with DDE_Panel

ddeChan = DDEInitiate("Windmill", "Data")

'Keeps conversation open until the required number of 'samples

‘have been collected.

While NoOfRows < NoOfSamples + 1

'Requests data from all channels and stores it in

‘memory in an array called mydata.

mydata = DDERequest(ddeChan, "AllChannels")

'Selects first sheet in default workbook.

Sheets("Sheet1").Select

'Finds the lower & upper boundaries of array, to determine the

‘number of columns needed to store the data.

Lower = LBound(mydata, 1)

Upper = UBound(mydata, 1)

'Inserts data from the array into a row of cells.

For Column = Lower To Upper

Cells(NoOfRows,Column).Value = mydata(Column)

Next Column

'Waits for the specified sample interval.

Application.Wait (Now + SamplePeriod)

'Increments number of rows, so next set of samples is inserted in the next row down.

NoOfRows = NoOfRows + 1

'Stops loop when required sets of samples collected.

Wend

DDETerminate (ddeChan)

End Sub

For more macros, and tips on using Windmill with Excel, see the Windmill web site -

http://www.windmill.co.uk/excel.html


Example Visual Basic Macro

Visual Basic objects, such as label and text box controls, have inherent DDE capabilities. You can define the DDE conversation by changing the object's methods and properties. For example, for a label object called Label1

Label1.LinktopicDefines the Service and Topic names of DDE Server applications

Label1.LinkItemDefines the DDE Item name

Label1.LinkModeDefines the type of DDE link

Label1.LinkRequestUpdates the label's text using data from the DDE Server

Other methods are available for sending data to a DDE Server, using DDE Execute commands for example. Full details of these methods and properties are contained in the Microsoft Visual Basic Language Reference Manual.

Example macro

Comments are shown in italic

Sub Timer1_Timer()

' This timer control is used to update a text control Label1.

' A DDE link is established between Windmill and the text

' control and a new data value is acquired for the control

' which may be found in Label1.Text.

Label1.LinkTopic = "Windmill|Data"' DDE Service and Topic

Label1.LinkItem = "OvenTemp"' DDE Item Name

Label1.LinkMode = 2' 0=no link

' 1=warm link

' 2=cold link

Label1.LinkRequest' Request Data from

' Windmill DDE Panel

Label1.LinkMode = 0' Close the link

End Sub


Commands

File menu

Load Hardware Setup
Save Panel Setup
Restore Panel Setup
DDE
Exit

Connections menu

Display menu


Error Messages

Error 20 | No reply received - problem with link to acquisition hardware.
Error 22 | Timed out while waiting for reply from hardware.
Error 29 | Transmission error.
Error 100 | The version of DDE Panel you are running is a demonstration version, it does not work with this hardware.
Error 104 | Hardware failed to accept data.
Error 105 | Hardware failed to supply data.
Error 106 | Hardware failed to configure correctly.
Error 107 | Error in hardware communications
Error 108 | Input value is out of range.
Error 109 | Output value is out of range.
Error 114 | Data not yet ready - try again later.
Error 324 | Wrong type of data supplied (e.g. letters instead of numbers)


World Wide Web

Web Site

You can find more information about Windmill Software on the World Wide Web at http://www.windmill.co.uk/.

Every month we publish a free newsletter - Monitor ((ISSN 1472-0221), delivered by e-mail. This gives tips on using Windmill and articles on data acquisition and control. To subscribe visit http://www.windmill.co.uk/newsletter.html.

For easy purchase of extra software modules visit http://www.windmillsoft.com/.

Updates of this Help file will be posted at http://www.windmill.co.uk/help.html.


Your Comments on the Help

Tell us any improvements we could make to our Help files. Could you quickly find what you wanted? Was the explanation clear? Have you any questions? Visit http://www.windmill.co.uk/help.html and fill in the comments form at the bottom of the page.


Licence a Trial Copy of Windmill

Subscribers to our newsletter can download a fully-working, trial version of Windmill and the ComIML serial driver. This lets you collect data from almost any device which plugs into the PC's COM port. At the end of your trial, if you wish to keep using the software, you can purchase a release key for just £50 from our data acquisition shop. This will let you go on using your set-up indefinitely.

To obtain a release key:

  1. Run the Windmill ConfIML program and click the Software button.
  2. You will see a screen showing your software and a Request Key. Make a note of the Request Key.
  3. Go to the Windmill data acquisition shop and add Licence your trial version of Windmill to your shopping cart.
  4. During the checkout process you will be asked for your Request Key. Enter this.
  5. One of our team will send you back your Release Key. Enter this in the ConfIML Software Authorization screen you saw earlier. Your software will be re-enabled and you can continue to use it.

Thank you for using Windmill
http://www.windmill.co.uk/
http://www.windmillsoft.com/


Windmill

Windmill is a suite of data acquisition and control software. It comprises:

Drivers - which handle the low-level communications

ConfIML - which creates a file holding details on which hardware devices are in your system

SetupIML - which creates files telling the other applications how you want the hardware configured

Applications - such as Logger and Chart which perform the data acquisition and control tasks


Contacting Windmill Software

Windmill Software, PO Box 58, North District Office, Manchester, M8 8QR, UK.
Telephone: +44 (0)161 833 2782
Facsimile: +44 (0)161 833 2190
E-mail: sales@windmill.co.uk
http://www.windmillsoft.com/
http://www.windmill.co.uk/

Every month we publish a free newsletter - Monitor (ISSN 1472-0221), delivered by e-mail. This gives tips on using Windmill and articles on data acquisition and control. To subscribe visit http://www.windmill.co.uk/newsletter.html.

For easy purchase of extra software modules visit http://www.windmillsoft.com/.

Updates of this Help file will be posted at http://www.windmill.co.uk/help.html.


DDE Protocol Notes

Dynamic Data Exchange is a standard protocol. Windmill supports the following parts of the DDE protocol, allowing external applications to control it.

INITIATE

When an external application wants to start a conversation with a Windmill program.

REQUEST

When the external application wants to obtain some information from a Windmill program.

ADVISE

When the application wants to be kept informed of all changes in a data value.

POKE

When the application wants to send a data value to an output channel.

TERMINATE

When either program wants to end the conversation.


Windmill DDE Panel Help contents

Windmill DDE Panel Help Index

Getting Started

Overview

Configuring the hardware

Selecting channels to display

Stopping the panel

Setting DDE Panel's Display Options

Changing the refresh rate

Turning the units on and off

Turning the status bar on and off

Saving DDE Panel's Details

Saving DDE Panel's setup details

Restoring DDE Panel's setup details

Loading the setup details automatically

Automatically starting DDE Panel when you switch on the computer

Altering the hardware setup file

Closing DDE Panel

Sharing Information with Other Applications

Selecting which channels are copied to the clipboard

Copying data to the clipboard

Dynamic Data Exchange (DDE)

Changing the DDE service name

Sharing information with other applications

Types of information: DDE topics

Sending commands to the DDE Panel from other applications

Network DDE

Example Excel Macro to read data

Example Excel Macro to send data to an output channel

Example Excel Macro to repeatedly sample data

Example Visual Basic Macro

Reference

Command summary

Error messages

World Wide Web

Your comments on the Help


Copying Data to the Clipboard

You can use the Clipboard to establish DDE links between applications on the same computer, or simply to copy the current values into another application. Select the Copy to Clipboard button and choose the type of information you want to copy.


Changing the DDE Service Name

For a DDE conversation to take place the DDE Panel must have a unique Service Name. The first instance of the panel is given the Service Name "Windmill". You may wish to run several copies of the panel, however, and in this case you will have to choose new Service Names for the additional copies.

To do this select DDE from the File menu.

A dialogue box appears for you to select a DDE Service Name.


File Menu

Load Hardware Setup

Configures the hardware by sending it a hardware setup file of your choice (an *.ims file).

Related topics:

Configuring the hardware

Save Panel Setup

Saves DDE Panel's current settings in a setup file of your choice (a *.wdp file).

Related topics:

Saving DDE Panel's setup details

Restore Panel Setup

Loads a previously saved DDE Panel setup file of your choice (a *.wdp file).

Related topics:

Restoring DDE Panel's setup details

DDE

Gives the panel a DDE service name, and network password, of your choice.

Related topics:

Changing the DDE service name

Exit

Closes DDE Panel.

Related topics:

Closing DDE Panel


Connections Menu

The Connections menu calls up a dialogue box where you can select which channels are connected to DDE Panel.

Related topics:

Selecting channels to display


Display Menu

Units

Toggles the data units on and off.

Related topics:

Turning the units on and off

Status Bar

Toggles the status bar on and off

Related topics:

Turning the status bar on and off


Service Name

Windows programs cannot make DDE conversations unless they have a unique DDE Service Name. To change or allocate a Service Name to a program choose DDE from the File menu and fill in the dialogue box.


Dynamic Data Exchange (DDE)

DDE is a standard protocol that allows co-operating Windows applications to transfer data in real-time. Windmill DDE Panel is a DDE Server. It allows DDE Client programs to obtain the connected channel names, units, current data values, etc. You can also use DDE to send commands to DDE Panel. These DDE facilities are available between programs on one computer and between different computers across a network.

The Copy to Clipboard button makes it easy to establish links between programs on a single computer. However this does not work between different computers on a network. For networked systems you need to run the DDEShare Utility supplied by Microsoft Windows.

Notes

Data is exchanged within the Windmill system automatically. You only need DDE if you wish to link a Windmill program to some other application, such as a spreadsheet or database.

The remote application may send or request data to or from any of the currently connected channels as and when required. Alternatively a Hot link or Automatic Link may be used, with the Windmill program sending new data to the other application as it becomes available. Additional information, such as channel names, units, alarm states and error codes, can also be obtained by remote applications.


Author

Windmill DDE Panel Help

designed and written
by Jill Studholme
http://www.studholme.net/